#ifndef _lcthw_stack_h
#define _lcthw_stack_h
#include <lcthw/list.h>

typedef List Stack;
typedef ListNode StackNode;

static inline Stack *Stack_create()
{
	return (Stack *) List_create();
}

static inline void Stack_destroy(Stack *stack)
{
	List_destroy((List *)stack);
}

static inline void *Stack_peek(Stack *stack)
{
	return List_last((List *) stack);
}

static inline void Stack_push(Stack *stack, void *value)
{
	List_push((List *)stack, value);
}

static inline void *Stack_pop(Stack *stack)
{
	return List_pop((List *)stack);
}

static inline int Stack_count(Stack *stack)
{
	return List_count((List *) stack);
}

#define STACK_FOREACH(S,C) ListNode *_node = NULL; \
	ListNode *C = NULL;\
	for(C = _node = S->last; _node != NULL; C = _node = _node->prev)

#endif
